* Example for the use of FMYSQL driver
* (c) 2001 by Tore Van Grembergen <torevg@albatros-logistics.be>
* See details and description in README.fmysql
*
* Compile:
* either a) all-at-once:
*   FlagShip fmy*.prg mysqltest.prg -Mmain -o mysqltest -I/usr/include/mysql -L/usr/lib/mysql -lmysqlclient
* or better b) modularily:
*   FlagShip fmysql.prg fmyrs.prg -c -m -na -I/usr/include/mysql
*   FlagShip mysqltest.prg -m -Mmain fmysql.o fmyrs.o -L/usr/lib/mysql -lmysqlclient -lgz -o mysqltest
* or best c)
*   make
* Run: ./mysqltest

function main()
    LOCAL aDB
    LOCAL no := 0
    LOCAL aParam := {}
    LOCAL aParamlist :={}
    LOCAL oError    AS ERROR
    LOCAL rs

    SET DATE FRENCH
    SET CENTURY ON

    BEGIN SEQUENCE

        MYDBOPEN("albatros", "localhost", "root", "")
        ? "Connection opened"


        BEGIN SEQUENCE
          MYBEGIN()
          ?"command executed"

          aParam := {"omschrijving","test"}
          AADD(aParamlist,aParam)

          ? MYEXEC("insert into woorden (omschrijving) values (:omschrijving)",aParamlist)
          ?"command executed"

          ? MYINSERTID()
          ?"command executed"

          ? MYEXEC(" delete from woorden where omschrijving = 'test'")
          ?"command executed"

          MYCOMMIT()
          ?"command executed"

        RECOVER
          MYROLLBACK()
          ?"command executed"
          ? "recover 2 could not execute insert or delete -> transactions are undone"
        END


        BEGIN SEQUENCE
        ? MYQTOTXT("select * from vaten")
        ?"command executed"
        RECOVER
          ? "recover 3 could not execute select to txt "
        END

        BEGIN SEQUENCE
          ? MYQTODBF("select * from vaten")
          ?"command executed"
        RECOVER
          ? "recover 4 could not execute select to dbf "
        END

        BEGIN SEQUENCE
          aDB := MYQTOMEM("select * from vaten")
          ?"command executed"
          aeval(aDB,{|elem|IF(VALTYPE(elem)=="A",(QOUT(++no,":"),AEVAL(elem,{|subelem|QQOUT(subelem)})),QOUT(++no,":",elem,VALTYPE(elem)))})
        RECOVER
          ? "recover 5 could not execute select to MEM "
        END

        BEGIN SEQUENCE
          no := 0
          aDB := MYQTODBMEM("select * from vaten2")
          ?"command executed"
          aeval(aDB,{|elem|IF(VALTYPE(elem)=="A",(QOUT(++no,":"),AEVAL(elem,{|subelem|QQOUT(subelem)})),QOUT(++no,":",elem,VALTYPE(elem)))})
        RECOVER
          ? "recover 6 could not execute select to MEM "
        END


        ? MYSTAT()
        ?"command executed"

        BEGIN SEQUENCE
          aParamlist := {}
          aParam := {"vatnr",10}
          AADD(aParamlist,aParam)
          aDB := MYQTODBMEM("select * from vaten where vatnr = :vatnr",aParamlist)
          ?"command executed"
          aeval(aDB,{|elem|IF(VALTYPE(elem)=="A",(QOUT(++no,":"),AEVAL(elem,{|subelem|QQOUT(subelem)})),QOUT(++no,":",elem,VALTYPE(elem)))})
        RECOVER
          ? "recover 7 could not execute select to MEM with parameters "
        END

        BEGIN SEQUENCE
          rs := MYQTORS("select bak from bestellijnen limit 10")
          ?"command executed"
          ? "nr records retrieved = " + STR(rs:RECCOUNT())
          WHILE .NOT. rs:EOF()
            ? "recordnumber =  ",rs:RECNO(),rs:bestellnr,rs:omschrijving
            rs:SKIP()
          ENDDO
          ?
          ?
          rs:GOTOP()

          ?"Go TOP "
          ?"*******"
          ? "recordnumber =  " + STR(rs:RECNO())
          ? rs:FIELDINFO(1,LEFT("omschrijving",10))
          ? rs:FIELDINFO(2,1)
          ? rs:FIELDGET(10)
          ? rs:FIELDGET(LEFT("omschrijving",10))
          ?

          rs:GOBOTTOM()

          ?"Go BOTTOM "
          ?"*******"
          ? "recordnumber =  " + STR(rs:RECNO())
          ? rs:FIELDGET(10)
          ? rs:FIELDGET(LEFT("omschrijving",10))
          rs:GOTO(rs:RECCOUNT())
          ? "recordnumber =  " + STR(rs:RECNO())

        RECOVER USING oError
            MYALERT(oError)
        END

        BEGIN SEQUENCE
            ? "test insert + delete 1"
            ? "*************"
            ? INSERT1("Nieuw Kantoorke" , 1 , 1 , 1)
        RECOVER USING oError
            MYALERT(oError)
        ENDSEQUENCE

         MYDBCLOSE()
        ? "Connection closed"
    RECOVER
        ? "recover 1 : could not connect to the database"
    END

return nil


FUNCTION INSERT1(cNaam , nTaalnr , nAccsysnr , nAdresnr)
    LOCAL nKey      AS INTVAR
    LOCAL oError
    LOCAL aParams   AS ARRAY
    LOCAL cSQL      AS STRING
    local lDoBreak  AS LOGICAL

    lDoBreak := .F.

    AADD(aParams,{"naam",cNaam})
    AADD(aParams,{"taalnr",nTaalnr})
    AADD(aParams,{"accsysnr",nAccsysnr})
    AADD(aParams,{"adresnr",nAdresnr})
    AADD(aParams,{"gebrkrnrcr", 1})
    AADD(aParams,{"gebrkrnrup", 1})
    AADD(aParams,{"datcreatie", DATE()})
    AADD(aParams,{"datupdate", DATE()})

    cSQL := "INSERT INTO accijnskantoren "
    cSQL := cSQL + "( naam, "
    cSQL := cSQL + "taalnr, "
    cSQL := cSQL + "accsysnr, "
    cSQL := cSQL + "adresnr, "
    cSQL := cSQL + "gebrkrnrcr, "
    cSQL := cSQL + "gebrkrnrup, "
    cSQL := cSQL + "datcreatie, "
    cSQL := cSQL + "datupdate ) "
    cSQL := cSQL + "VALUES ( :naam, "
    cSQL := cSQL + ":taalnr, "
    cSQL := cSQL + ":accsysnr, "
    cSQL := cSQL + ":adresnr, "
    cSQL := cSQL + ":gebrkrnrcr, "
    cSQL := cSQL + ":gebrkrnrup, "
    cSQL := cSQL + ":datcreatie, "
    cSQL := cSQL + ":datupdate ) "

    BEGIN SEQUENCE
        MYBEGIN()
        MYEXEC(cSQL,aParams)
        nKey := MYINSERTID()
        MYCOMMIT()
    RECOVER USING oError
        MYROLLBACK()
        lDoBreak := .T.
    ENDSEQUENCE

    IF lDoBreak = .T.
           IF ISBEGSEQ()
              BREAK(oError)
           ELSE
              MYALERT(oError)
           ENDIF
    ENDIF

RETURN nKey

FUNCTION DELETE1(nAcckantnr)
    LOCAL nKey      AS INTVAR
    LOCAL oError    AS ERROR
    LOCAL aParams   AS ARRAY
    LOCAL cSQL      AS STRING
    LOCAL lDoBreak  AS LOGICAL

    lDoBreak := .F.

    AADD(aParams,{"acckantnr",nAcckantnr})

    cSQL := "DELETE FROM accijnskantoren "
    cSQL := cSQL + "WHERE acckantnr = :acckantnr "


    BEGIN SEQUENCE
        MYBEGIN()
        MYEXEC(cSQL,aParams)
        nKey := MYINSERTID()
        MYCOMMIT()
    RECOVER USING oError
        MYROLLBACK()
        lDoBreak := .T.
    ENDSEQUENCE

    IF lDoBreak = .T.
           IF ISBEGSEQ()
              BREAK(oError)
           ELSE
              MYALERT(oError)
           ENDIF
    ENDIF

RETURN NIL
